<?php

class DispletRetsIdxUpdates extends DispletRetsIdxPlugin{
	public function maybe_update(){
		$last_version = DispletRetsIdxSettings::get_option('version');
		if (empty($last_version) || version_compare('2.0.26', $last_version, '>')) { // using old update methodology
			$user_role_version = get_option('displet_rets_idx_user_role_version');
			if (empty($user_role_version) || $user_role_version < 2){
				DispletRetsIdxUsers::add_custom_user_role_for_leads();
				if ($user_role_version < 2) {
					DispletRetsIdxUsersUpdates::upgrade_users_to_role_2();
				}
			}
			$user_role_version_agents = get_option('displet_rets_idx_user_role_version_agents');
			if (empty($user_role_version_agents) || $user_role_version_agents < 2){
				DispletRetsIdxUsers::add_custom_user_role_for_agents();
			}
			$user_role_version_admin = get_option('displet_rets_idx_user_role_version_admin');
			if (empty($user_role_version_admin) || $user_role_version_admin < 1){
				DispletRetsIdxUsers::add_custom_capabilities_to_admin();
			}
			$version = get_option('displet_rets_idx_options_version');
			if (empty($version) || $version < 1) {
				if (empty($version) || $version < 1) {
					DispletRetsIdxSettingsUpdates::update_settings_to_version_1();
				}
				update_option('displet_rets_idx_options_version', 1);
			}
		}
		if (version_compare(self::$plugin_version, $last_version, '>')) { // last version not current
			if (version_compare('2.0.24', $last_version, '>')) { // last version before 2.0.24
				self::update_to_2_0_24();
			}
			if (version_compare('2.0.25', $last_version, '>')) {
				self::update_to_2_0_25();
			}
			if (version_compare('2.0.26', $last_version, '>')) {
				self::update_to_2_0_26();
			}
			if (version_compare('2.0.27', $last_version, '>')) {
				self::update_to_2_0_27();
			}
			if (version_compare('2.0.28', $last_version, '>')) {
				self::update_to_2_0_28();
			}
			if (version_compare('2.0.30', $last_version, '>')) {
				self::update_to_2_0_30();
			}
			if (version_compare('2.0.31', $last_version, '>')) {
				self::update_to_2_0_31();
			}
			DispletRetsIdxSettings::update_option('version', self::$plugin_version);
		}
	}

	private function update_to_2_0_24(){
		DispletRetsIdxUsersUpdates::schedule_register_non_api_users_with_api_cron();
	}

	private function update_to_2_0_25(){
		DispletRetsIdxUrlStructure::reset_flush_rewrite_rules();
	}

	private function update_to_2_0_26(){
		DispletRetsIdxSettingsUpdates::change_to_multi_checkbox_from_one_per_line_textarea('city_include_filter');
	}

	private function update_to_2_0_27(){
		DispletRetsIdxUsersUpdates::save_new_meta_values_for_user_searches();
	}

	private function update_to_2_0_28(){
		DispletRetsIdxUsers::add_custom_capabilities_to_admin();
	}

	private function update_to_2_0_30(){
		DispletRetsIdxUrlStructure::reset_flush_rewrite_rules();
	}

	private function update_to_2_0_31(){
		DispletRetsIdxSettingsUpdates::update_setting('require_registration_to_view_properties', '1');
	}
}

add_action('init', array('DispletRetsIdxUpdates', 'maybe_update'));

?>