<?php
	global $displetretsidx_option;
	$search_results_url = get_permalink($displetretsidx_option['search_results_page_id']);
	$property_details_url = get_permalink($displetretsidx_option['property_details_page_id']);
	$is_admin = current_user_can('manage_options');
	$page = !empty($_GET['pagenum']) ? intval($_GET['pagenum']) : 1;
	$unpaged_url = preg_replace('/&pagenum=(\d+)/', '', $_SERVER["REQUEST_URI"]);
	$previous_url = $unpaged_url . '&pagenum=' . ($page - 1);
	$next_url = $unpaged_url . '&pagenum=' . ($page + 1);
	$leads = DispletRetsIdxUsers::get_leads();
	if (!empty($leads) && is_array($leads)) { // AustinHomeSeller.com custom functionality
		$user_has_address = false;
		foreach ($leads as $lead) {
			if (!empty($lead->displet_user_submitted_address)) {
				$user_has_address = true;
			}
		}
	}
?>
<div id="displet-lead-manager" class="wrap">
	<h2>Displet Lead Manager</h2>
	<?php if ((!empty($page) && $page != 1) || count($leads) == 25) : ?>
		<table class="form-table">
			<tr>
				<?php if (!empty($page) && $page != 1) : ?>
					<td>
						<a href="<?php echo $previous_url; ?>" class="displet-left">Previous Page</a>
					</td>
				<?php endif; ?>
				<?php if (count($leads) == 25) : ?>
					<td class="displet-next">
						<a href="<?php echo $next_url; ?>" class="displet-right">Next Page</a>
					</td>
				<?php endif; ?>
			</tr>
		</table>
	<?php endif; ?>
	<table class="displet-leads form-table">
		<tr valign="top">
			<th class="checkbox"></th>
			<th>Name</th>
			<th>Email</th>
			<th>Phone</th>
			<?php if (!empty($displetretsidx_option['include_working_with_realtor'])) : ?>
				<th>Has Realtor</th>
			<?php endif; ?>
			<th>Avg Price</th>
			<th>Avg Sq Ft</th>
			<th>Top Zip Code</th>
			<?php if ($user_has_address) : ?>
				<th>Address</th>
			<?php endif; ?>
			<?php if ($is_admin) : ?>
				<th>Assigned To</th>
			<?php endif; ?>
		</tr>
		<?php if (!empty($leads)) : foreach ($leads as $lead) :
			// Newer leads stored as timestamp
			if (is_numeric($lead->displet_last_login)) {
				$lead->last_login = date('Y/m/d \a\t g:ia', $lead->displet_last_login);
			}
			// Older leads stored in date format
			else{
				$lead->last_login = $lead->displet_last_login;
			}
			$lead->edit_url = admin_url('user-edit.php?user_id=' . $lead->ID);
			if ($is_admin) {
				$assigned_agent_id = get_user_meta($lead->ID, 'displet_agent_id', true);
				if (!empty($assigned_agent_id)) {
					$assigned_agent = get_userdata(intval($assigned_agent_id));
					$assigned_to = $assigned_agent->display_name;
				}
				else{
					$assigned_to = 'Unassigned';
				}
			}
			$searches_markup = '';
			if (!empty($lead->displet_user_hashes)) {
				foreach ($lead->displet_user_hashes as $hash) {
					$searches_markup .= '<a href="' . $search_results_url . $hash . '" target="_blank">' . $search_results_url . $hash . '</a><br>';
				}
			}
			$properties_markup = '';
			if (!empty($lead->displet_user_properties)) {
				foreach ($lead->displet_user_properties as $property) {
					if (!empty($property['url'])){
						$property['address'] = (!empty($property['address'])) ? $property['address'] : 'Property';
						$properties_markup .= '<a href="' . $property_details_url . $property['url'] . '" target="_blank">' . $property['address'] . '</a><br>';
					}
				}
			}
			$favorites_markup = '';
			if (!empty($lead->displet_saved_properties)) {
				foreach ($lead->displet_saved_properties as $property) {
					if (!empty($property['url'])) {
						if (!empty($property['type'])) {
							$favorites_markup .= ucwords($property['type']) . ' - ';
						}
						if (!empty($property['rating'])) {
							$favorites_markup .= $property['rating'] . '/5 stars: ';
						}
						$favorites_markup .= '<a href="' . $property_details_url . $property['url'] . '" target="_blank">' . DispletRetsIdxUtilities::get_address_from_property_details_suffix($property['url']) . '</a><br>';
					}
				}
			}
			$saved_searches_markup = '';
			if (!empty($lead->displet_saved_searches)) {
				foreach ($lead->displet_saved_searches as $saved_search) {
					if ($saved_search['hash']) {
						$saved_search['name'] = !empty($saved_search['name']) ? $saved_search['name'] : $search_results_url . $saved_search['hash'];
						$saved_searches_markup .= '<a href="' . $search_results_url . $saved_search['hash'] . '" target="_blank">' . $saved_search['name'] . '</a><br>';
					}
				}
			}
			$showings_markup = '';
			if (!empty($lead->displet_property_inquiries)) {
				foreach ($lead->displet_property_inquiries as $property_inquiry) {
					$showings_markup .= 'Name: ' . $property_inquiry['name'] . ' Email: ' . $property_inquiry['email'] . ' Phone: ' . $property_inquiry['phone'] . ' Address: ' . $property_inquiry['address'] . ' Appointment 1: ' . $property_inquiry['first_appointment'] . ' Appointment 2: ' . $property_inquiry['second_appointment'] . ' Message: ' . $property_inquiry['message'] . '<br>';
				}
			}
		?>
			<tr class="displet-lead">
				<td class="checkbox">
					<input id="<?php echo $lead->ID; ?>" type="checkbox">
				</td>
				<td>
					<?php echo $lead->nickname; ?>
					<a href="javascript:;" id="displet-lead-<?php echo $lead->ID; ?>" class="displet-user">
						(Details)
					</a>
				</td>
				<td>
					<a href="mailto:<?php echo $lead->user_email; ?>"><?php echo $lead->user_email; ?></a>
				</td>
				<td>
					<?php echo $lead->displet_phone; ?>
				</td>
				<?php if (!empty($displetretsidx_option['include_working_with_realtor'])) : ?>
					<td>
						<?php echo $lead->displet_realtor; ?>
					</td>
				<?php endif; ?>
				<td>
					$<?php if (!empty($lead->displet_mean_price)) echo number_format($lead->displet_mean_price); ?>
				</td>
				<td>
					<?php if (!empty($lead->displet_mean_square_feet)) echo number_format($lead->displet_mean_square_feet); ?>
				</td>
				<td>
					<?php echo $lead->displet_zip_mode; ?>
				</td>
				<?php if ($user_has_address) : ?>
					<td>
						<?php echo $lead->displet_user_submitted_address; ?>
					</td>
				<?php endif; ?>
				<?php if ($is_admin) : ?>
					<td>
						<?php echo $assigned_to; ?>
					</td>
				<?php endif; ?>
			</tr>
			<tr class="displet-lead-details displet-lead-<?php echo $lead->ID; ?>">
				<td></td>
				<td class="displet-lead-details-table-wrapper" colspan="8">
					<table class="form-table">
						<tr>
							<td>
								<a href="<?php echo $lead->edit_url; ?>">
									Edit User
								</a>
							</td>
						</tr>
						<tr>
							<td>
								<label>
									Registered:
								</label>
								<?php echo get_date_from_gmt($lead->user_registered, 'Y/m/d \a\t g:ia'); ?>
								at
								<a href="<?php echo $lead->displet_registration_url; ?>" target="_blank">
									<?php echo $lead->displet_registration_url; ?>
								</a>
							</td>
							<td>
								<label>
									Registered From:
								</label>
								<a href="<?php echo $lead->displet_registration_upstream_url; ?>" target="_blank">
									<?php echo $lead->displet_registration_upstream_url; ?>
								</a>
							</td>
						</tr>
						<tr>
							<td>
								<label>
									Last Login:
								</label>
								<?php echo $lead->last_login; ?>
							</td>
							<td>
								<label>
									Total Logins:
								</label>
								<?php echo $lead->displet_logins_count; ?>
							</td>
						</tr>
						</tr>
							<td>
								<label>
									Searched for:
								</label>
								<?php echo $searches_markup; ?>
							</td>
							<td>
								<label>
									Viewed:
								</label>
								<?php echo $properties_markup; ?>
							</td>
						</tr>
						<tr>
							<td>
								<label>
									Favorites:
								</label>
								<?php echo $favorites_markup; ?>
							</td>
							<td>
								<label>
									Saved Searches:
								</label>
								<?php echo $saved_searches_markup; ?>
							</td>
						</tr>
						<tr>
							<td>
								<label>
									Showing/Info Requests:
								</label>
								<?php echo $showings_markup; ?>
							</td>
						</tr>
					</table>
				</td>
			</tr>
		<?php endforeach; else : ?>
			<tr>
				<td colspan="9">
					There are no leads
					<?php echo ($_SERVER["REQUEST_URI"] == 'page=displet-lead-manager') ? 'at this time' : 'that match your search criteria'; ?>
				</td>
			</tr>
		<?php endif;?>
	</table>
	<?php if ((!empty($page) && $page != 1) || count($leads) == 25) : ?>
		<table class="form-table">
			<tr>
				<?php if (!empty($page) && $page != 1) : ?>
					<td>
						<a href="<?php echo $previous_url; ?>" class="displet-left">Previous Page</a>
					</td>
				<?php endif; ?>
				<?php if (count($leads) == 25) : ?>
					<td class="displet-next">
						<a href="<?php echo $next_url; ?>" class="displet-right">Next Page</a>
					</td>
				<?php endif; ?>
			</tr>
		</table>
	<?php endif; ?>
	<table class="displet-user-action form-table">
		<tr valign="top">
			<td>
				<a href="javascript:;" id="displet_delete_selected_users" class="button-primary">Delete Selected Users</a>		
			</td>
			<?php if ($is_admin) : ?>
				<td>
					Assign Selected Users to:
					<select id="displet_assigned_agent">
						<?php
							$admin_users_array = get_users(array('role' => 'administrator'));
							$agent_users_array = get_users(array('role' => 'displet_agent'));
							$users_array = array();
							if (!empty($admin_users_array)) {
								$users_array = array_merge($admin_users_array, $users_array);
							}
							if (!empty($agent_users_array)) {
								$users_array = array_merge($agent_users_array, $users_array);
							}
							if (!empty($users_array)) {
								foreach ($users_array as $user) {
									echo '<option value="' . $user->ID . '">' . $user->display_name . '</option>';
								}
							}
						?>
					</select>
					<a href="javascript:;" id="displet_reassign_selected_users" class="button-primary">Assign</a>
				</td>
			<?php endif; ?>
		</tr>
	</table>
	<h3>
		Search Leads
	</h3>
	<form action="<?php echo admin_url('admin.php'); ?>" method="get">
		<input type="hidden" name="page" value="displet-lead-manager">
		<table class="displet-user-search form-table">
			<tr valign="top">
				<th scope="row">
					<label for="user_name">
						Name
					</label>
				</th>
				<td>
					<input type="text" id="user_name" name="user_name"<?php if (!empty($_GET['user_name'])) echo ' value="' . $_GET['user_name'] . '"'; ?>/>
				</td>
				<th scope="row">
					<label for="user_email">
						Email
					</label>
				</th>
				<td>
					<input type="text" id="user_email" name="user_email"<?php if (!empty($_GET['user_email'])) echo ' value="' . $_GET['user_email'] . '"'; ?>/>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row">
					<label for="user_phone">
						Phone
					</label>
				</th>
				<td>
					<input type="text" id="user_phone" name="user_phone"<?php if (!empty($_GET['user_phone'])) echo ' value="' . $_GET['user_phone'] . '"'; ?>/>
				</td>
				<th scope="row">
					<label for="has_phone">
						User Has Phone?
					</label>
				</th>
				<td>	
					<input type="checkbox" id="has_phone" name="has_phone" value="1"<?php checked($_GET['has_phone']); ?>/>	
				</td>
			</tr>
			<tr valign="top">
				<th scope="row">
					<label for="logged_in_since">
						Last Login Since
					</label>
				</th>
				<td>	
					<input type="text" id="logged_in_since" name="logged_in_since"<?php if (!empty($_GET['logged_in_since'])) echo ' value="' . $_GET['logged_in_since'] . '"'; ?>/>		
				</td>
				<th scope="row">
					<label for="min_logins">
						Min Logins
					</label>
				</th>
				<td>
					<input type="text" id="min_logins" name="min_logins"<?php if (!empty($_GET['min_logins'])) echo ' value="' . preg_replace('/[^0-9]/', '', $_GET['min_logins']) . '"'; ?>/>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row">
					<label for="min_saved_properties">
						Min Saved Properties
					</label>
				</th>
				<td>
					<input type="text" id="min_saved_properties" name="min_saved_properties"<?php if (!empty($_GET['min_saved_properties'])) echo ' value="' . preg_replace('/[^0-9]/', '', $_GET['min_saved_properties']) . '"'; ?>/>
				</td>
				<th scope="row">
					<label for="min_saved_searches">
						Min Saved Searches
					</label>
				</th>
				<td>
					<input type="text" id="min_saved_searches" name="min_saved_searches"<?php if (!empty($_GET['min_saved_searches'])) echo ' value="' . preg_replace('/[^0-9]/', '', $_GET['min_saved_searches']) . '"'; ?>/>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row">
					<label for="min_showing_requests">
						Min Showing/Info Requests
					</label>
				</th>
				<td>
					<input type="text" id="min_showing_requests" name="min_showing_requests"<?php if (!empty($_GET['min_showing_requests'])) echo ' value="' . preg_replace('/[^0-9]/', '', $_GET['min_showing_requests']) . '"'; ?>/>
				</td>
				<th scope="row">
					<label for="zip_mode">
						Top Zip Code
					</label>
				</th>
				<td>
					<input type="text" id="zip_mode" name="zip_mode"<?php if (!empty($_GET['zip_mode'])) echo ' value="' . $_GET['zip_mode'] . '"'; ?>/>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row">
					<label for="mean_price_min">
						Average Price Min
					</label>
				</th>
				<td>
					<input type="text" id="mean_price_min" name="mean_price_min"<?php if (!empty($_GET['mean_price_min'])) echo ' value="' . preg_replace('/[^0-9]/', '', $_GET['mean_price_min']) . '"'; ?>/>
				</td>
				<th scope="row">
					<label for="mean_price_max">
						Average Price Max
					</label>
				</th>
				<td>
					<input type="text" id="mean_price_max" name="mean_price_max"<?php if (!empty($_GET['mean_price_max'])) echo ' value="' . preg_replace('/[^0-9]/', '', $_GET['mean_price_max']) . '"'; ?>/>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row">
					<label for="mean_square_feet_min">
						Average Square Feet Min
					</label>
				</th>
				<td>
					<input type="text" id="mean_square_feet_min" name="mean_square_feet_min"<?php if (!empty($_GET['mean_square_feet_min'])) echo ' value="' . preg_replace('/[^0-9]/', '', $_GET['mean_square_feet_min']) . '"'; ?>/>
				</td>
				<th scope="row">
					<label for="mean_square_feet_max">
						Average Square Feet Max
					</label>
				</th>
				<td>
					<input type="text" id="mean_square_feet_max" name="mean_square_feet_max"<?php if (!empty($_GET['mean_square_feet_max'])) echo ' value="' . preg_replace('/[^0-9]/', '', $_GET['mean_square_feet_max']) . '"'; ?>/>
				</td>
			</tr>
		</table>
		<p class="submit">
			<input type="submit" value="Search" class="button-primary">
		</p>
	</form>
</div>